//
//  SiiPrinter.h
//

#import <Foundation/Foundation.h>
#import <SIIPrinterManager/SIIPrinterManager.h>

/// A class defines informatioms for printer
///
/// Properties:
///  - model: Printer model number (Int32)
///  - type: Printer port type number (Int32)
///  - address: Printer address (String)
///  - modelName: Printer model name (String)
///  - portType: Printer port type name (String)
///  - seriesName: Printer series name (String)
@interface SiiPrinter : NSObject {
    NSInteger type;
    NSInteger model;
    NSString *address;
    NSString *modelName;
    NSString *portType;
    NSString *seriesName;
}

@property NSInteger type;
@property NSInteger model;
@property NSString *address;
@property NSString *modelName;
@property NSString *portType;
@property NSString *seriesName;

- (instancetype)initWithPrinterInformation:(NSString *)address modelName:(NSString *)modelName portType:(NSString *)portType;
- (NSString *)getPrinterModelName:(NSString *)seriesName;
- (NSInteger)getPrinterModel:(NSString *)modelName;
- (NSString *)getPrinterPortType:(NSInteger)type;
- (NSInteger)getPrinterType:(NSString *)portType;
@end

